Index: sansview/perspectives/fitting/basepage.py
===================================================================
--- sansview/perspectives/fitting/basepage.py	(revision 9466f2d6a8ec770363ff314de3d4768470b1a6f6)
+++ sansview/perspectives/fitting/basepage.py	(revision 22963162e77a658f5b9affbe8d77c9cda810b0a3)
@@ -2368,15 +2149,6 @@
         self.disp_list should change type later .now only gaussian
         """
-        n = self.disp_box.GetCurrentSelection()
-        name = self.disp_box.GetValue()
-        dispersity= self.disp_box.GetClientData(n)
-        self.disp_name = name
-        
-        if name.lower() == "array":
-            self._set_sizer_arraydispersion()
-        else:
-            self._set_sizer_dispersion(dispersity= dispersity)
-            
-        self.state.disp_box= n
+        self._set_sizer_dispersion()
+
         ## Redraw the model
         self._draw_model() 
@@ -2389,90 +2161,181 @@
         self.SetupScrolling()
     
-    def _set_sizer_arraydispersion(self):
-        """
-        draw sizer with array dispersity  parameters
-        """
-        
+    def _on_disp_func(self, event=None): 
+        """
+        Select a distribution function for the polydispersion
+        
+        :Param event: ComboBox event 
+        """
+        # get ready for new event
+        if event != None:
+            event.Skip()
+        # Get event object
+        disp_box =  event.GetEventObject() 
+
+        # Try to select a Distr. function
+        try:   
+            disp_box.SetBackgroundColour("white")
+            selection = disp_box.GetCurrentSelection()
+            param_name = disp_box.Name.split('.')[0]
+            disp_name = disp_box.GetValue()
+            dispersity= disp_box.GetClientData(selection)
+    
+            #disp_model =  GaussianDispersion()
+            disp_model = dispersity()
+            # Get param names to reset the values of the param
+            name1 = param_name + ".width"
+            name2 = param_name + ".npts"
+            name3 = param_name + ".nsigmas"
+            # Check Disp. function whether or not it is 'array'
+            if disp_name.lower() == "array":
+                value2= ""
+                value3= ""
+                value1 = self._set_array_disp(name=name1, disp=disp_model)
+            else:
+                self._del_array_values(name1)
+                #self._reset_array_disp(param_name)
+                self._disp_obj_dict[name1] = disp_model
+                self.model.set_dispersion(param_name, disp_model)
+                self.state._disp_obj_dict[name1]= disp_model
+ 
+                value1= str(format_number(self.model.getParam(name1), True))
+                value2= str(format_number(self.model.getParam(name2)))
+                value3= str(format_number(self.model.getParam(name3)))
+            # Reset fittable polydispersin parameter value
+            for item in self.fittable_param:
+                 if item[1] == name1:
+                    item[2].SetValue(value1) 
+                    item[5].SetValue("")
+                    item[6].SetValue("")
+                    # Disable for array
+                    if disp_name.lower() == "array":
+                        item[0].SetValue(False)
+                        item[0].Disable()
+                        item[2].Disable()
+                        item[5].Disable()
+                        item[6].Disable()
+                    else:
+                        item[0].Enable()
+                        item[2].Enable()
+                        item[5].Enable()
+                        item[6].Enable()                       
+                    break
+            # Reset fixed polydispersion params
+            for item in self.fixed_param:
+                if item[1] == name2:
+                    item[2].SetValue(value2) 
+                    # Disable Npts for array
+                    if disp_name.lower() == "array":
+                        item[2].Disable()
+                    else:
+                        item[2].Enable()
+                if item[1] == name3:
+                    item[2].SetValue(value3) 
+                    # Disable Nsigs for array
+                    if disp_name.lower() == "array":
+                        item[2].Disable()
+                    else:
+                        item[2].Enable()
+                
+            # Make sure the check box updated when all checked
+            if self.cb1.GetValue():
+                self.select_all_param(None)
+
+            # update params
+            self._update_paramv_on_fit() 
+            # draw
+            self._draw_model()
+            self.Refresh()
+        except:
+            # Error msg
+            msg = "Error occurred:"
+            msg += " Could not select the distribution function..."
+            msg += " Please select another distribution function."
+            disp_box.SetBackgroundColour("pink")
+            # Focus on Fit button so that users can see the pinky box
+            self.btFit.SetFocus()
+            wx.PostEvent(self.parent.parent, 
+                         StatusEvent(status=msg, info="error"))
+        
+        
+    def _set_array_disp(self, name=None, disp=None):
+        """
+        Set array dispersion
+        
+        :param name: name of the parameter for the dispersion to be set
+        :param disp: the polydisperion object
+        """
+        # The user wants this parameter to be averaged. 
+        # Pop up the file selection dialog.
+        path = self._selectDlg()
+        # Array data
+        values = []
+        weights = []
+        # If nothing was selected, just return
+        if path is None:
+            self.disp_cb_dict[name].SetValue(False)
+            #self.noDisper_rbox.SetValue(True)
+            return
+        self._default_save_location = os.path.dirname(path)
+
+        basename  = os.path.basename(path)
+        values,weights = self.read_file(path)
+        
+        # If any of the two arrays is empty, notify the user that we won't
+        # proceed
         if len(self.param_toFit)>0:
-            for item in self.fittable_param:
-                if item in self.param_toFit:
-                    self.param_toFit.remove(item)
-            for item in self.orientation_params_disp:
-                if item in self.param_toFit:
-                    self.param_toFit.remove(item)
-        for item in self.model.details.keys():
-            if item in self.model.fixed:
-                del self.model.details [item]                           
-
-        self.fittable_param=[]
-        self.fixed_param=[]
-        self.orientation_params_disp=[]
-        self.sizer4_4.Clear(True) 
-        self._reset_dispersity()
-        ix=0
-        iy=1     
-        disp1 = wx.StaticText(self, -1, 'Array Dispersion')
-        self.sizer4_4.Add(disp1,( iy, ix),(1,1),  wx.LEFT|wx.EXPAND|wx.ADJUST_MINSIZE, 15)
-        
-        # Look for model parameters to which we can apply an ArrayDispersion model
-        # Add a check box for each parameter.
-        self.disp_cb_dict = {}
-        ix+=1 
-        self.noDisper_rbox = wx.RadioButton(self, -1,"None", (10, 10),style= wx.RB_GROUP)
-        self.Bind(wx.EVT_RADIOBUTTON,self.select_disp_angle , id=self.noDisper_rbox.GetId())
-        #MAC needs SetValue
-        self.noDisper_rbox.SetValue(True)
-        self.sizer4_4.Add(self.noDisper_rbox, (iy, ix),
-                           (1,1), wx.EXPAND|wx.ADJUST_MINSIZE, 0)
-        
-        for p in self.model.dispersion.keys():
-            if not p in self.model.orientation_params:
-                ix+=1 
-                self.disp_cb_dict[p] = wx.RadioButton(self, -1, p, (10, 10))
-                self.state.disp_cb_dict[p]=  self.disp_cb_dict[p].GetValue()
-                self.Bind(wx.EVT_RADIOBUTTON, self.select_disp_angle, id=self.disp_cb_dict[p].GetId())
-                self.sizer4_4.Add(self.disp_cb_dict[p], (iy, ix), (1,1), wx.EXPAND|wx.ADJUST_MINSIZE, 0)
-        
-        for p in self.model.dispersion.keys():
-            if p in self.model.orientation_params:
-                ix+=1 
-                self.disp_cb_dict[p] = wx.RadioButton(self, -1, p, (10, 10))
-                self.state.disp_cb_dict[p]=  self.disp_cb_dict[p].GetValue()
-                if not (self.enable2D or self.data.__class__.__name__ =="Data2D"):
-                    self.disp_cb_dict[p].Hide()
-                else:
-                    self.disp_cb_dict[p].Show(True)
-                self.Bind(wx.EVT_RADIOBUTTON, self.select_disp_angle, id=self.disp_cb_dict[p].GetId())
-                self.sizer4_4.Add(self.disp_cb_dict[p], (iy, ix), (1,1), wx.EXPAND|wx.ADJUST_MINSIZE, 0)
-
-
-        ix =0
-        iy +=1 
-        self.sizer4_4.Add((20,20),(iy,ix),(1,1), wx.LEFT|wx.EXPAND|wx.ADJUST_MINSIZE, 15)        
-        self.Layout()
-
-        self.state.orientation_params =[]
-        self.state.orientation_params_disp =[]
-        self.state.parameters =[]
-        self.state.fittable_param =[]
-        self.state.fixed_param =[]
-        
-        ## save checkbutton state and txtcrtl values
-        
-        self._copy_parameters_state(self.orientation_params,
-                                     self.state.orientation_params)
-
-        self._copy_parameters_state(self.orientation_params_disp,
-                                     self.state.orientation_params_disp)
-        
-        self._copy_parameters_state(self.parameters, self.state.parameters)
-        self._copy_parameters_state(self.fittable_param, self.state.fittable_param)
-        self._copy_parameters_state(self.fixed_param, self.state.fixed_param)
-        
-        
-        ## post state to fit panel
-        event = PageInfoEvent(page = self)
-        wx.PostEvent(self.parent, event)
-   
+            if name in self.param_toFit:
+                self.param_toFit.remove(name)
+
+        # Tell the user that we are about to apply the distribution
+        msg = "Applying loaded %s distribution: %s" % (name, path)
+        wx.PostEvent(self.parent.parent, StatusEvent(status=msg))  
+
+        disp.set_weights(values, weights)
+        self._disp_obj_dict[name] = disp
+        self.model.set_dispersion(name.split('.')[0], disp)
+        self.state._disp_obj_dict[name]= disp
+        self.values[name] = values
+        self.weights[name] = weights
+        # Store the object to make it persist outside the
+        # scope of this method
+        #TODO: refactor model to clean this up?
+        self.state.values = {}
+        self.state.weights = {}
+        self.state.values = copy.deepcopy(self.values)
+        self.state.weights = copy.deepcopy(self.weights)
+
+        # Set the new model as the dispersion object for the 
+        #selected parameter
+        #self.model.set_dispersion(p, disp_model)
+        # Store a reference to the weights in the model object 
+        #so that
+        # it's not lost when we use the model within another thread.
+        #TODO: total hack - fix this
+        self.state.model= self.model.clone()
+        self.model._persistency_dict[name.split('.')[0]] = \
+                                        [values, weights]
+        self.state.model._persistency_dict[name.split('.')[0]] = \
+                                        [values,weights]
+        return basename
+    
+    def _del_array_values(self, name=None):  
+        """
+        Reset array dispersion
+        
+        :param name: name of the parameter for the dispersion to be set 
+        """
+        # Try to delete values and weight of the names array dic if exists
+        try:
+            del self.values[name]
+            del self.weights[name]
+            # delete all other dic
+            del self.state.values[name]
+            del self.state.weights[name]
+            del self.model._persistency_dict[name.split('.')[0]] 
+            del self.state.model._persistency_dict[name.split('.')[0]]
+        except:
+            pass
+                                            
     def _lay_out(self):
         """
@@ -2494,4 +2357,22 @@
             time.sleep(1)
             
+    def _find_polyfunc_selection(self, disp_func = None):
+        """
+        FInd Comboox selection from disp_func 
+        
+        :param disp_function: dispersion distr. function
+        """
+        # List of the poly_model name in the combobox
+        list = ["RectangleDispersion", "ArrayDispersion", 
+                    "LogNormalDispersion", "GaussianDispersion", 
+                    "SchulzDispersion"]
+
+        # Find the selection
+        try:
+            selection = list.index(disp_func.__class__.__name__)
+            return selection
+        except:
+             return 3
+                            
     def on_reset_clicked(self,event):
         """
@@ -2556,4 +2437,36 @@
         #Re draw plot
         self._draw_model()
+        
+    def get_images(self):
+        """
+        Get the images of the plots corresponding this panel for report
+        
+        : return graphs: list of figures
+        : TODO: Move to guiframe
+        """
+        # set list of graphs
+        graphs = []
+        canvases = []
+        # call gui_manager
+        gui_manager = self.parent.parent
+        # loops through the panels [dic]
+        for item1, item2 in gui_manager.panels.iteritems():
+             data_title = self.data.group_id
+             data_name = self.data.name
+            # try to get all plots belonging to this control panel
+             try:
+                 # check titles (main plot) 
+                 # and data_names (model plot[2D], and residuals)
+                 if item2.group_id == data_title or \
+                                item2.window_name.count(data_name):
+                     #panel = gui_manager._mgr.GetPane(item2.window_name)
+                     # append to the list
+                     graphs.append(item2.figure) 
+                     canvases.append(item2.canvas)     
+             except:
+                 # Not for control panels
+                 pass
+        # return the list of graphs
+        return graphs, canvases
 
     def on_model_help_clicked(self,event):
@@ -2562,5 +2475,9 @@
         """
         from help_panel import  HelpWindow
-        
+        import sans.models as models 
+        
+        # Get models help model_function path
+        path = models.get_data_path(media='media')
+        model_path = os.path.join(path,"model_functions.html")
         if self.model == None:
             name = 'FuncHelp'
@@ -2568,5 +2485,5 @@
             name = self.model.origin_name
 
-        frame = HelpWindow(None, -1,  pageToOpen="media/model_functions.html")    
+        frame = HelpWindow(None, -1,  pageToOpen=model_path)    
         frame.Show(True)
         if frame.rhelp.HasAnchor(name):
@@ -2575,4 +2492,187 @@
            msg= "Model does not contains an available description "
            msg +="Please try searching in the Help window"
-           wx.PostEvent(self.parent.parent, StatusEvent(status = msg ))                    
+           wx.PostEvent(self.parent.parent, StatusEvent(status = msg ))      
+    
+    def on_pd_help_clicked(self, event):
+        """
+        Button event for PD help
+        """
+        from help_panel import  HelpWindow
+        import sans.models as models 
+        
+        # Get models help model_function path
+        path = models.get_data_path(media='media')
+        pd_path = os.path.join(path,"pd_help.html")
+
+        frame = HelpWindow(None, -1,  pageToOpen=pd_path)    
+        frame.Show(True)
+        
+    def on_left_down(self, event):
+        """
+        Get key stroke event
+        """
+        # Figuring out key combo: Cmd for copy, Alt for paste
+        if event.CmdDown() and event.ShiftDown():
+            flag = self.get_paste()
+        elif event.CmdDown():
+            flag = self.get_copy()
+        else:
+            event.Skip()
+            return
+        # make event free
+        event.Skip()
+        # messages depending on the flag
+        if flag == None:
+            msg = " Parameter values are copied to the clipboard..."
+            infor = 'warning'
+        elif flag:
+            msg = " Parameter values are pasted from the clipboad..."
+            infor = "warning"
+        else:
+            msg = "Error was occured during pasting the parameter values "
+            msg += "from the clipboard..."
+            infor = "error"
+        # inform msg to wx
+        wx.PostEvent( self.parent.parent, 
+                      StatusEvent(status= msg, info=infor))
+        
+            
+    def get_copy(self): 
+        """
+        Get the string copies of the param names and values in the tap
+        """  
+        content = 'sansview_parameter_values:'
+        # Do it if params exist        
+        if  self.parameters !=[]:
+            
+            # go through the parameters 
+            string = self._get_copy_helper(self.parameters, 
+                                           self.orientation_params)
+            content += string
+            
+            # go through the fittables
+            string = self._get_copy_helper(self.fittable_param, 
+                                           self.orientation_params_disp)
+            content += string
+
+            # go through the fixed params
+            string = self._get_copy_helper(self.fixed_param, 
+                                           self.orientation_params_disp)
+            content += string
                 
+            # go through the str params
+            string = self._get_copy_helper(self.str_parameters, 
+                                           self.orientation_params)
+            content += string
+
+        if wx.TheClipboard.Open():
+            wx.TheClipboard.SetData(wx.TextDataObject(str(content)))
+            data = wx.TextDataObject()
+            success = wx.TheClipboard.GetData(data)
+            text = data.GetText()
+            wx.TheClipboard.Close()
+            
+        return None
+    
+    def _get_copy_helper(self, param, orient_param):
+        """
+        Helping get value and name of the params
+        
+        : param param:  parameters
+        : param orient_param = oritational params
+        : return content: strings [list] [name,value:....]
+        """
+        content = ''
+        # go through the str params
+        for item in param: 
+            # 2D
+            if self.data.__class__.__name__== "Data2D":
+                name = item[1]
+                value = item[2].GetValue()
+            # 1D
+            else:
+                ## for 1D all parameters except orientation
+                if not item[1] in orient_param:
+                    name = item[1]
+                    value = item[2].GetValue()
+            # add to the content
+            content += name + ',' + value + ':'
+            
+        return content
+    
+    def get_paste(self): 
+        """
+        Get the string copies of the param names and values in the tap
+        """  
+        context = {}
+        text = ""
+        
+        # Get text from the clip board        
+        if wx.TheClipboard.Open():
+            if wx.TheClipboard.IsSupported(wx.DataFormat(wx.DF_TEXT)):
+                data = wx.TextDataObject()
+                # get wx dataobject
+                success = wx.TheClipboard.GetData(data)
+                # get text
+                text = data.GetText()
+            # close clipboard
+            wx.TheClipboard.Close()
+            
+        # put the text into dictionary    
+        lines = text.split(':')
+        if lines[0] != 'sansview_parameter_values':
+            return False
+        for line in lines[1:-1]:
+            if len(line) != 0:
+                item =line.split(',')
+                name = item[0]
+                value = item[1]
+                # Transfer the text to content[dictionary]
+                context[name] = value
+        
+        # Do it if params exist        
+        if  self.parameters != []:
+            # go through the parameters  
+            self._get_paste_helper(self.parameters, 
+                                   self.orientation_params, context)
+
+            # go through the fittables
+            self._get_paste_helper(self.fittable_param, 
+                                   self.orientation_params_disp, context)
+
+            # go through the fixed params
+            self._get_paste_helper(self.fixed_param, 
+                                   self.orientation_params_disp, context)
+            
+            # go through the str params
+            self._get_paste_helper(self.str_parameters, 
+                                   self.orientation_params, context)
+            
+        return True
+    
+    def _get_paste_helper(self, param, orient_param, content):
+        """
+        Helping set values of the params
+        
+        : param param:  parameters
+        : param orient_param: oritational params
+        : param content: dictionary [ name, value: name1.value1,...] 
+        """
+        # go through the str params
+        for item in param: 
+            # 2D
+            if self.data.__class__.__name__== "Data2D":
+                name = item[1]
+                if name in content.keys():
+                    item[2].SetValue(content[name])
+            # 1D
+            else:
+                ## for 1D all parameters except orientation
+                if not item[1] in orient_param:
+                    name = item[1]
+                    if name in content.keys():
+                        # Avoid changing combox content which needs special care
+                        if item[2].__class__.__name__ != "ComboBox":
+                            item[2].SetValue(content[name])
+                            
+                
Index: sansview/perspectives/fitting/console.py
===================================================================
--- sansview/perspectives/fitting/console.py	(revision 66ff25070134c0c0c680c52e02ee279ffccc378f)
+++ sansview/perspectives/fitting/console.py	(revision 22963162e77a658f5b9affbe8d77c9cda810b0a3)
@@ -116,11 +116,9 @@
         """
         """
-        #self.elapsed_time = time.time() - self.elapsed_time
-        #msg = " Updating fit ...\n result:\n %s \n"%self.result.__str__()
-        #wx.PostEvent(self.parent, StatusEvent(status=msg, info="info",
-        #                                  type="progress"))
-        #if self.manager is not None:
-        #    self.manager.update_fit(msg=msg, result=self.result)
-        #time.sleep(0.01)
+        self.elapsed_time = time.time() - self.elapsed_time
+        msg = " Updating fit ...\n result:\n %s \n"%self.result.__str__()
+        wx.PostEvent(self.parent, StatusEvent(status=msg, info="info",
+                                              type="progress"))
+        time.sleep(0.01)
         
     def starting_fit(self):
Index: sansview/perspectives/fitting/fit_thread.py
===================================================================
--- sansview/perspectives/fitting/fit_thread.py	(revision 58e0c83b06bd83e2ec0b20ea6725239ec020d0fc)
+++ sansview/perspectives/fitting/fit_thread.py	(revision 22963162e77a658f5b9affbe8d77c9cda810b0a3)
@@ -15,6 +15,6 @@
                  updatefn   = None,
                  yieldtime  = 0.01,
-                 worktime   = 0.01
-                 ):
+                 worktime   = 0.01,
+                 ftol       = None):
         CalcThread.__init__(self,completefn,
                  updatefn,
@@ -27,4 +27,6 @@
         self.starttime = 0
         self.updatefn = updatefn
+        #Relative error desired in the sum of squares.
+        self.ftol = ftol
    
     def isquit(self):
